
/* Copyright (C) 1993 Free Software Association of Germany

   The following is only valid, if you use this outside the Federal
   Republic of Germany.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   If you don't have a a copy of the GNU General Public License
   write to the Free Software Foundation, Inc., 675 Mass Ave, 
   Cambridge, MA 02139, USA.

   (C)opyright 1993,1994 FREE SOFTWARE ASSOCIATION OF GERMANY

   ----------------------------------------------------------------

   Fuer die Nutzung dieses Quell-Codes innerhalb der Bundesrepublik
   Deutschland gilt:

   Dieses Programm ist freie Software und kann unter den Bedingungen
   der Deutschen Free Software Lizenz weitergeben und/oder modifiziert
   werden.

   Wir haben dieses Programm in der Hoffnung entwickelt, dass es
   sich als nuetzlich erweist. Wir uebernehmen jedoch *KEINERLEI*
   Garantien auf die Funktion oder Verwendbarkeit dieses Programms.
   Der Anwender nutzt dieses Programm * AUF EIGENES RISIKO *

   Diesem Programm sollte eine Kopie der Deutschen Free Software Lizenz
   (DFSL) beigefuegt sein. Falls nicht, kann eine Kopie von uns angefordert
   werden: Free Software Association of Germany, Heimatring 19,
   60596 Frankfurt (info@elara.fsag..de), Telefon: ++49 - 69 - 6312083

   (C)opyright 1993,1994 FREE SOFTWARE ASSOCIATION OF GERMANY */




#include <stdio.h>
#include <sys/types.h>
#include <stdio.h>
#include <pwd.h>

#ifdef  HPUX
#include <sys/stdsyms.h>
#endif

#ifdef svr4 
#include <shadow.h>
#endif
#ifdef linux
#include <fshadow.h>
#endif
#ifdef aix
#include <userpw.h>
#endif
#include <grp.h>
#include <fcntl.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/un.h>
#include <arpa/inet.h>
#if defined linux 
#include <sys/errno.h>
#include <sys/file.h>
#include <sys/dir.h>
#endif
#ifdef sun
#include <errno.h>
#include <sys/file.h>
#include <dirent.h>
#endif

#ifdef svr4
#include <errno.h>
#include <dirent.h>
#endif
#ifdef aix
#include <errno.h>
#include <dirent.h>
#endif
#include <sys/stat.h>
#include <syslog.h>

#ifdef	HPUX
#include <errno.h>
#include <sys/dirent.h>
extern char *sys_errlist[];
#endif

#define GREAT_SERVER
#define SERVER_SYSTEM THIS_SERVER
#define SERVER_OS THIS_OS
/* #define COPYDEBUG */

#define INTERNAL_NOPERM "Denied by server configuration"

char user[100];
char pass[100];
char *uhome;

int verified = 0;
unsigned long dir_size;
unsigned int next;

#ifndef INADDR_NONE
#define INADDR_NONE 0xffffffff
#endif

struct sockaddr_in	tcp_srv_addr;
struct sockaddr_in	myctladdr;
struct sockaddr_in	data_addr;
struct servent		tcp_serv_info;
struct hostent		tcp_host_info;


char GREAT_login[512];
#define MAXLINE 150
#define VERSION_MAJOR 0
#define VERSION_MINOR 99

char brk_arg[20][MAXLINE];
int brk_cnt = 0;

/* #define DEBUG */

#if defined svr4 || defined sun || defined aix
extern char *sys_errlist[];
#endif

int VERBOSE  = 0;
char g_testdir[2048];
struct stat g_testdirstb;
int data_handle = -1;

FILE *infp, *outfp;

struct	_perms	{
	char no_special;
	char no_root;
	char read_only;
	char no_root_files;
	char log;
	char logall;
	char shadow;
	char stream;
	char *guest;
	char *chroot;
	int guest_uid;
	} perms;


void clean_up(int sig)
{
	if (data_handle > 0)
		close(data_handle);
	syslog(LOG_NOTICE|LOG_USER,"terminated due to signal %d",sig);
	exit(0);
}


main(int argc, char **argv)
{
	FILE *fp,*netfp;
	struct group *gw;
	struct passwd *pw;
	char tmp[2048];
	char *t;
	int hd,a,b,c;
	int had,sz;
	char tst[2048];
	char txt[1024];
	struct stat stb;
	DIR *dir;
	struct dirent *entry;
	char *ex[20];
	int mode,ccv;
	time_t zeit;


	for (a = 1; a < 15; a++)
		signal(a,clean_up);


	time(&a);
	Xsrand(a);
	ccv = Xrand(4999);	

	if (!strcmp(argv[1],"-v"))
		VERBOSE = 1;

	read_conf();
	while (1)	{
		alarm(3600);
		if (verified == 0)	{
			if (user[0] != 0 && pass[0] != 0)	{
				login(user,pass,ccv);
				if (!verified)	{
					net_write("999 Access denied\r\n");
					exit(2);
					}
				net_write("900 User ok\r\n");
				fflush(stdout);
				}
			}
		get_line(tmp,2047);
		if (!strcmp(tmp,"help")) {
			help_info();
			continue;
			}
		if (atoi(tmp) == 20)	{
			brk_args(tmp);
			if (perms.log)
				syslog(LOG_NOTICE|LOG_USER,"Cryptkey request, user: %s",brk_arg[1]);
			if(!get_cryptkey(brk_arg[1],brk_arg[2],brk_arg[3],tst))
				sprintf(tmp,"120 000 %s\n",tst);
			else	{
				if (perms.log)
					syslog(LOG_NOTICE|LOG_USER,"Unvalid Crayptkey request (%s)",brk_arg[1]);
				sprintf(tmp,"120 001 0\n");
				}
			net_write(tmp);
			continue;
			}
		if (atoi(tmp) == 999)	{
			if (perms.log)
				syslog(LOG_NOTICE|LOG_USER,"Logout");
			net_write("999 Bye\r\n");
			exit(0);
			}
		if (atoi(tmp) == 1)	{
			strcpy(user,&tmp[4]);  /* 001 Username */
			continue;
			}	
		if (atoi(tmp) == 2)	{
			strcpy(pass,&tmp[4]);  /* 002 Password (crypted) */
			continue;
			}

		if (atoi(tmp) == 45)	{	/* TIME */
			time(&zeit);
			sprintf(tmp,"145 %08X\n",zeit);
			net_write(tmp);
			continue;
			}

		if (!verified)	{
			net_write("900 Command ignored\r\n");
			if (perms.log)
				syslog(LOG_NOTICE|LOG_USER,"Unautorized; <%s>",tmp);
			fflush(stdout);
			continue;
			}

		if (perms.logall)
			 syslog(LOG_NOTICE|LOG_USER,"cmd: <%s>",tmp);

		if (atoi(tmp) == 3)	{      /* 003 len  = getpwd(NULL,len) */
			sprintf(tmp,"103 %s\r\n",getcwd(NULL,atoi(&tmp[4])));
			net_write(tmp);
			continue;
			}


		if (atoi(tmp) == 24)	{      /* open Append */
			if(test_open(&tmp[4],"a"))	{
				sprintf(tmp,"124 000 %d\r\n",errno);
                   		net_write(tmp);
				continue;
				}

			hd = open(&tmp[4],O_WRONLY|O_CREAT|O_APPEND,0644);
			if (hd < 0)
				hd = 0;
			sprintf(tmp,"124 %03d %d\r\n",hd,errno);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 25)	{     /* lseek */
			brk_args(tmp);
			a = lseek(atoi(brk_arg[1]),atoi(brk_arg[2]),atoi(brk_arg[3]));
			if (a < 0)
				sprintf(tmp,"125 001 %d\n",errno);
			else
				sprintf(tmp,"125 000 %d\n",a);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 26)	{   /* Remove files recursive */
			if(test_open(&tmp[4],"w"))	{
				sprintf(tmp,"126 001 %d\r\n",errno);
                   		net_write(tmp);
				continue;
				}
			dir_size = 0;
			if (net_removetree(&tmp[4],tst,1))
				sprintf(tmp,"126 001 %d ,%s\n",errno,tst);
			else
				sprintf(tmp,"126 000 %d\n",dir_size/512);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 27)	{   /* Expand */
			if (net_expand(&tmp[4]))
				sprintf(tmp,"127 001 %d ,%s\n",errno,tst);
			else
				sprintf(tmp,"127 000 000\n");
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 4)	{      /* open READ */
			if(test_open(&tmp[4],"r"))	{
				sprintf(tmp,"104 000 %d\r\n",errno);
                   		net_write(tmp);
				continue;
				}
			hd = open(&tmp[4],O_RDONLY);
			if (hd < 0)
				hd = 0;
			sprintf(tmp,"104 %03d %d\r\n",hd,errno);
			net_write(tmp);
			continue;
			}
		if (atoi(tmp) == 5)	{	/* close File */
			hd = atoi(&tmp[4]);
			if (close(hd))	{
				sprintf(tmp,"105 001 %d\n",errno);
				net_write(tmp);
				continue;
				}
			sprintf(tmp,"105 000 %d\n",errno);
			net_write(tmp);
			continue;
			}
		if (atoi(tmp) == 7)	{      /* open WRITE*/
			if(test_open(&tmp[4],"w"))	{
				sprintf(tmp,"107 000 %d\r\n",errno);
                   		net_write(tmp);
				continue;
				}
			hd = open(&tmp[4],O_WRONLY|O_CREAT|O_TRUNC,0644);
			if (hd < 0)
				hd = 0;
			sprintf(tmp,"107 %03d %d\r\n",hd,errno);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 21)	{      /* LOCK FILE*/
#if defined linux || defined sun
			if (flock(atoi(&tmp[4]),LOCK_EX|LOCK_NB))
#endif
#ifdef svr4
			if (lockf(atoi(&tmp[4]),F_TLOCK,0))
#endif
#if defined(aix) || defined(HPUX)
			if (lockf(atoi(&tmp[4]),F_TLOCK,0))
#endif
				sprintf(tmp,"121 001 %d\n",errno);
			else
				sprintf(tmp,"121 000\n");
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 22)	{	/* Get Home */
			sprintf(tmp,"122 %s\n",uhome);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 10)	{	/* Delete File */
			if(test_open(&tmp[4],"w"))	{
				sprintf(tmp,"110 001 %d\r\n",errno);
                   		net_write(tmp);
				continue;
				}
			if (unlink(&tmp[4]))
				sprintf(tmp,"110 001 %d\n",errno);
			else
				sprintf(tmp,"110 000 000\n");
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 36)	{	/* Request resources */
			display_resources(&tmp[4]);
			continue;
			}

		if (atoi(tmp) == 35)	{	/* Request information */
			if (!strcmp(&tmp[4],"@system"))	{
				sprintf(tmp,"135 002 %s\n",SERVER_SYSTEM);
				net_write(tmp);
				continue;
				}
			if (!strcmp(&tmp[4],"@os"))	{
				sprintf(tmp,"135 002 %s\n",SERVER_OS);
				net_write(tmp);
				continue;
				}				
			send_info(tmp);
			continue;
			}

		if (atoi(tmp) == 34)	{	/* Get size of file or dir */
			dir_size = 0;
			if (net_removetree(&tmp[4],tst,0))
				sprintf(tmp,"134 001 %d ,%s\n",errno,tst);
			else
				sprintf(tmp,"134 000 %d\n",dir_size/512);
			net_write(tmp);
			continue;
			}


		if (atoi(tmp) == 32)	{	/* Get name from uid */
			pw = (struct passwd *)getpwuid(atoi(&tmp[4])); 
			if (pw == (struct passwd *)NULL)
				sprintf(tmp,"132 unknown\n");
			else
				sprintf(tmp,"132 %s\n",pw->pw_name);
			net_write(tmp);
			endpwent();
			continue;
			}

		if (atoi(tmp) == 33)	{	/* Get name from gid */
			gw = (struct group *)getgrgid(atoi(&tmp[4]));
			if (gw == (struct group *)NULL)
				sprintf(tmp,"133 unknown\n");
			else
				sprintf(tmp,"133 %s\n",gw->gr_name);
			endgrent();
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 30)	{	/* Get uid from name */
			pw = (struct passwd *)getpwnam(&tmp[4]);
			if (pw == (struct passwd *)NULL)
				sprintf(tmp,"130 99999\n");
			else
				sprintf(tmp,"130 %d\n",pw->pw_uid);
			endpwent();
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 31)	{	/* Get gid from name */
			gw = (struct group *)getgrnam(&tmp[4]);
			if (gw == (struct group *)NULL)
				sprintf(tmp,"131 99999\n");
			else
				sprintf(tmp,"131 %d\n",gw->gr_gid);
			endgrent();
			net_write(tmp);
			continue;
			}


		if (atoi(tmp) == 29)	{	/* fstat File */
			if(fstat(atoi(&tmp[4]),&stb))	{
				sprintf(tmp,"129 001 %d\n",errno);
				net_write(tmp);
				continue;
				}
			sprintf(tmp,"129 000 %o %o %o %o %o %o %o %o %o %o %o\n",
				stb.st_dev,
				stb.st_ino,
				stb.st_mode,
				stb.st_nlink,
				stb.st_uid,
				stb.st_gid,
				stb.st_rdev,
				stb.st_size,
				stb.st_atime,
				stb.st_mtime,
				stb.st_ctime);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 28)	{	/* Stat File */
			if(stat(&tmp[4],&stb))	{
				sprintf(tmp,"128 001 %d\n",errno);
				net_write(tmp);
				continue;
				}
			sprintf(tmp,"128 000 %o %o %o %o %o %o %o %o %o %o %o\n",
				stb.st_dev,
				stb.st_ino,
				stb.st_mode,
				stb.st_nlink,
				stb.st_uid,
				stb.st_gid,
				stb.st_rdev,
				stb.st_size,
				stb.st_atime,
				stb.st_mtime,
				stb.st_ctime);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 11)	{	/* lstat File */
			if(lstat(&tmp[4],&stb))	{
				sprintf(tmp,"111 001 %d\n",errno);
				net_write(tmp);
				continue;
				}
			sprintf(tmp,"111 000 %o %o %o %o %o %o %o %o %o %o %o\n",
				stb.st_dev,
				stb.st_ino,
				stb.st_mode,
				stb.st_nlink,
				stb.st_uid,
				stb.st_gid,
				stb.st_rdev,
				stb.st_size,
				stb.st_atime,
				stb.st_mtime,
				stb.st_ctime);
			net_write(tmp);
			continue;
			}
		if (atoi(tmp) == 12)	{	/* dirlisting */
			dir = opendir(&tmp[4]);
			if (dir == NULL)	{
				sprintf(tmp,"012 001 %d\n",errno);
				net_write(tmp);
				continue;
				}
			while((entry = readdir(dir)) != NULL)	{
				if (entry->d_ino == 0)
					continue;
				sprintf(tmp,"012 000 (%s)\n",entry->d_name);
				net_write(tmp);
				}
			closedir(dir);
			sprintf(tmp,"012 999 %d\n",errno);
			net_write(tmp);
			continue;
			}	

		if (atoi(tmp) == 13)	{      /* chmod of file */
			brk_args(tmp);
			sscanf(brk_arg[1],"%o",&a);
			if(test_open(brk_arg[2],"w"))	{
				sprintf(tmp,"113 001 %d\r\n",errno);
                   		net_write(tmp);
				continue; 
				}
			if (chmod(brk_arg[2],a))
				sprintf(tmp,"113 001 %d\n",errno);
			else
				sprintf(tmp,"113 000 %d\n",errno);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 14)	{	/* Mkdir */
			brk_args(tmp);
			if(test_open(brk_arg[1],"w"))	{
				sprintf(tmp,"014 001 %d\r\n",errno);
                   		net_write(tmp);
				continue;
				}
			sscanf(brk_arg[2],"%o",&a);
			if (mkdir(brk_arg[1],a))
				sprintf(tmp,"114 001 %d\n",errno);
			else
				sprintf(tmp,"114 000 %d\n",errno);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 15)	{	/* Version */
			sprintf(tmp,"115 %03d.%03d GREATNET (c) FSAG\n"
				,VERSION_MAJOR
				,VERSION_MINOR);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 16)	{	/* Return Name of Error */
			a = atoi(&tmp[4]);
			tmp[0] = 0;
			if (a == 999)
				sprintf(tmp,"116 %s\n",INTERNAL_NOPERM);
			if (tmp[0] == 0)		
				sprintf(tmp,"116 %s\n",sys_errlist[atoi(&tmp[4])]);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 17)	{	/* access */
			brk_args(tmp);
			mode = 0;
	
			for (a = 2; a < 20; a++)	{
				if (brk_arg[a][0] == 0)
					break;
				if (!strcmp(brk_arg[a],"R_OK"))	{
					mode |= R_OK;
					continue;
					}
				if (!strcmp(brk_arg[a],"W_OK"))	{
					mode |= W_OK;
					continue; 
					}
				if (!strcmp(brk_arg[a],"X_OK"))	{
					mode |= X_OK;
					continue;
					}
				if (!strcmp(brk_arg[a],"F_OK"))	{
					mode |= F_OK;
					continue;
					}
				}

			if (access(brk_arg[1],mode))	
				sprintf(tmp,"117 001 %d\n",errno);
			else 
				sprintf(tmp,"117 000 %d\n",errno);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 40)	{ /* DataConnection */
			data_handle = datastream(tmp);
			if (data_handle <= 0)	{
				sprintf(tmp,"140 001 %d\n",errno);
				syslog(LOG_NOTICE|LOG_USER,"Can't open datastream: %s",
						sys_errlist[errno]);
				}

			else
				sprintf(tmp,"140 000 %03d\n",data_handle);
			net_write(tmp);
			infp = fdopen(data_handle,"r");
			outfp = fdopen(data_handle,"w");
			continue;
			}

		if (atoi(tmp) == 42)	{  /* StreamPermission */
			sprintf(tmp,"142 %03d\n",perms.stream);
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 41)	{ /* StreamWrite */
			a = atoi(&tmp[4]);
			if (perms.stream == 0)	{
				sprintf(tst,"141 001 999\n");
				net_write(tst);
				continue;
				}	
			strcpy(tst,&tmp[11]);
			fp = fopen(tst,"w");
			if (fp == NULL)	{
				sprintf(tst,"141 001 %03d\n",errno);
				net_write(tst);
				continue;
				}
			sprintf(tst,"141 000\n");
			net_write(tst);
			t = (char *)malloc(512);
			while (1)	{
				b = slow_read(fileno(infp),t,512);
				if (b < 0)	{
					if (perms.log)
                                	        syslog(LOG_NOTICE|LOG_USER,"Read error");
					exit(1);
					}
				if (b == 0)
					break;
				if(write(fileno(fp),t,b) != b)	{
					a = -1;
					if (perms.log)
                                	        syslog(LOG_NOTICE|LOG_USER,"Write error");
					exit(1);
					}
				
				}
			fclose(fp);
			exit(0);
			}

		if (atoi(tmp) == 39)	{ /* StreamRead */
			strcpy(tst,&tmp[4]);
			if (perms.stream == 0)	{
				sprintf(tst,"139 001 999\n");
				net_write(tst);
				continue;
				}	
			if (lstat(tst,&stb))	{
				sprintf(tst,"139 001 %03d\n",errno);
				net_write(tst);
				continue;
				}
			fp = fopen(tst,"r");
			if (fp == NULL)	{
				sprintf(tst,"139 001 %03d\n",errno);
				net_write(tst);
				continue;
				}
			sprintf(tst,"139 000 %d\n",stb.st_blksize);
			net_write(tst);
			t = (char *)malloc(stb.st_blksize);
			while (1)	{
				b = read(fileno(fp),t,stb.st_blksize);
				if (b < 0)	{
					if (perms.log)
                                	        syslog(LOG_NOTICE|LOG_USER,"Read error");
					exit(1);
					}
				if (b == 0)
					break;
				if(slow_write(data_handle,t,b) != b)	{
					a = -1;
					if (perms.log)
                                	        syslog(LOG_NOTICE|LOG_USER,"Write error");
					exit(1);
					}
				
				}
			close(a);
			exit(0);
			}
		if (atoi(tmp) == 38)	{ /* TestDir */
			if (atoi(&tmp[4]) == 1)	{
				strcpy(g_testdir,&tmp[8]);
				a = lstat(g_testdir,&g_testdirstb);
				if (a == 0)
					sprintf(tmp,"138 000 000\n");
				else	
					sprintf(tmp,"138 001 %03d\n",errno);
				net_write(tmp);
				continue;
				}
			a = local_testdir();
			if (a < 0)
                        	sprintf(tmp,"138 001 %03d\n",errno);      
			else 
				sprintf(tmp,"138 000 %03d\n",a);
			net_write(tmp);
			continue;	
			}


		if (atoi(tmp) == 19)	{	/* Link */
			if (llink(tmp))
				sprintf(tmp,"119 001 %d\n",errno);
			else
				sprintf(tmp,"119 000 000\n");
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 23)	{	/* Rename */
			if (rrename(tmp))
				sprintf(tmp,"123 001 %d\n",errno);
			else
				sprintf(tmp,"123 000 000\n");
			net_write(tmp);
			continue;
			}

		if (atoi(tmp) == 37)	{
			hd = fileno(popen(&tmp[4],"r"));
			if (hd <= 0)	{
				sprintf(tmp,"137 001 %d\n",errno);
				net_write(tmp);
			 	close(hd);
				continue;	
				}
			t = (char *)malloc(10241); 
			sprintf(tmp,"137 000 000\n");
			net_write(tmp);
			while (1)	{
				a = slow_read(hd,t,10240);
				if (a <= 0)
					break;
				if(slow_write(data_handle,t,a) != a)	{
					a = -1;
					break;
					}
				}
			close(hd);
			exit(0);
			}



		if (atoi(tmp) == 44)	{     /* DCE */
			a = data2user(&tmp[4]);
			if (a)	{
				sprintf(tmp,"144 001 %d\n",errno);
				if (a == -2)
					sprintf(tmp,"144 999 Permission denied\n");
				if (a == -3)
					sprintf(tmp,"144 998 No answer\n");
				net_write(tmp);
				continue;
				}
			exit(0);
			}

		if (atoi(tmp) == 43)	{
			brk_args(tmp);
			strcpy(tst,brk_arg[1]);
			strcpy(txt,brk_arg[2]);
			hd = open_resource(tst,txt);
			if (hd == 0)	{
				sprintf(tst,"143 000 %03d\n",errno);
				net_write(tst);
				continue;
				}
			if (hd < 0)	{
				strcpy(tst,"Server error");
				if (hd == -2)	
					strcpy(tst,"Unable to open config file");
				if (hd == -3)
					strcpy(tst,"Write only device");
				if (hd == -4)
					strcpy(tst,"Read only device");
				if (hd == -5)
					strcpy(tst,"Unknown open mode");
				if(hd == -6)
					strcpy(tst,"Unknown resource");
				if(hd == -7)
					strcpy(tst,"Mode Error in remote config file");
				sprintf(txt,"143 999 %s\n",tst);
				net_write(txt);
				continue;
				}
			sprintf(tst,"143 %03d\n",hd);		
			net_write(tst);
			continue;
			}

		if (atoi(tmp) == 18)	{	/* readlink */
			t = (char *)malloc(2048);
			a = readlink(&tmp[4],t,2047);
			if (a <= 0)	{
				sprintf(tmp,"118 001 %d\n",errno);
				net_write(tmp);
				free (t);
				continue;
				}
			t[a] = 0;
			sprintf(tmp,"118 000 %s\n",t);
			net_write(tmp);
			free (t);
			continue;
			}

		if (atoi(tmp) == 9)	{	/* chdir */
			if(test_open(&tmp[4],"r"))	{
				sprintf(tmp,"109 001 %d\r\n",errno); 
                   		net_write(tmp);
				continue;
				}
			if (chdir(&tmp[4]))	
				sprintf(tmp,"109 001 %d\n",errno);
			else
				sprintf(tmp,"109 000 000\n");
			net_write(tmp);
			continue;
			}
		if (atoi(tmp) == 8)	{	/* receive data */
			had = atoi(&tmp[4]);
			sz = atoi(&tmp[8]);
			if (had <= 0 || sz <= 0)	{
				sprintf(tmp,"108 000 001\n");
				net_write(tmp);
				continue;
				}
			sprintf(tmp,"108 %03d %d\n",had,sz);
			net_write(tmp);
			t = (char *)malloc(sz + 5);
			a = slow_read (fileno(infp),t,sz);
			if (a < 0)	{
				sprintf(tmp,"999 write error\n");
				syslog(LOG_NOTICE|LOG_USER,"008 write error");
				free(t);
				net_write(tmp);
				exit(0);
				}
			errno = 0;		
			b = write(had,t,a);
			c = b;
			if (b < 0)
				b = 0;
			sprintf(tmp,"108 %03d %d (%d)(%d)(%d)\n",b,errno,had,c,a);
			net_write(tmp);
			free(t);
			continue;
			}

		if (atoi(tmp) == 6)	{	/* read handle bytes */
			hd = atoi(&tmp[4]);
			a = atoi(&tmp[8]);
			if (hd <= 2 || a <= 0)	{
				net_write("106 000 001\r\n");
				continue;
				}
			t = (char *)malloc(a+1);
			b = read(hd,t,a);
			if (b < 0)	{
				b = 0;
				sprintf(tmp,"106 %03d %d\r\n",b,errno);
				}
			else
				sprintf(tmp,"106 %03d 00\n",b);

			net_write(tmp);
			if (b > 0)	{
				if (slow_write(fileno(outfp),t,b) != b)	{
					syslog(LOG_NOTICE|LOG_USER,"006 write error");
					exit(4);
					}
				}
			free(t);
			continue;
			}
		sprintf(tmp,"199 Unknown command\n");
		net_write(tmp);		
		}
}

int
net_write(char *s1)
{
	int a;

	a = write(fileno(stdout),s1,strlen(s1));
	if (a != strlen(s1))	{
		fprintf(stderr,"write error\n");
		exit(3);
		}
#ifdef DEBUG
	printf ("server: <%s> (%d)",s1,a);
#endif
}



login(char *us, char *pa,int ccv)
{
	char ip[300];
	char key[100];
	char tmp[500];
	char password[100];
	int ok = 0;

	struct passwd *p;
#ifndef aix
	struct spwd *sp;
#else
	struct userpw *sp;
#endif
	char salt[3];

	get_peerip(ip);

	if (perms.guest != NULL && perms.chroot != NULL)	{
		if (!strcmp(perms.guest,us))	{
			change_root();
			uhome = "/";
			if (chdir(uhome))	{
				if (perms.log)
                                        syslog(LOG_NOTICE|LOG_USER,"Can't chdir");
                                printf("999 Cannot chdir\r\n");
                                exit(1);
                                }

			if (setuid(perms.guest_uid))  {
       	                	if (perms.log)
       	                        	syslog(LOG_NOTICE|LOG_USER,"Can't setuid()");
	       	                printf("999 Cannot setuid()\r\n");
       		                exit(1);
				}
			if (perms.log)
				syslog(LOG_NOTICE|LOG_USER,"%s: (%s) user logged in",us,pa);
			verified = 1;
			return (0);
			}
		}
	p = getpwnam(us);
	if (p == (struct passwd *)NULL)	{
#ifdef DEBUG
		fprintf (stderr,"username <%s>  does not exists\n",us);
#endif 
		us[0] = pa[0] = 0;
		return;
		}
#ifdef DEBUG
	fprintf (stderr,"username <%s>  is (%s) ok\n",us,p->pw_dir);
#endif 
	if (p->pw_uid == 0)	{
		if (perms.no_root)	{
			printf("999 root access denied\n");
			exit(1);
			}
		}
	uhome = (char *)malloc(strlen(p->pw_dir) + 1);
	strcpy(uhome,p->pw_dir);

#ifdef svr4
	sp = getspnam(us);
	if (sp == (struct spwd *)NULL)	{
#endif

#ifdef linux
	ok = 1;

	if (perms.shadow == 0)	{
		strcpy(password,p->pw_passwd);
		if (password[0] == 0)
			ok = 0;
		}
	if (perms.shadow == 1)	{
		sp = getspnam(us);
		if (sp == (struct spwd *)NULL)
			ok = 0;
		}

	if (ok == 0)	{
#endif

#ifdef aix
	sp = getuserpw(us);
	if (sp == (struct userpw *)NULL)	{
#endif

#if defined(sun) || defined(HPUX)
	strcpy(password,p->pw_passwd);
	if (password[0] == 0)	{
#endif
#ifdef DEBUG
		fprintf(stderr,"no password-entry for <%s>\n",us);
#endif
		us[0] = pa[0] = 0;
		return;
		}
#ifdef aix
		strcpy(password,sp->upw_passwd);
#endif
#if defined linux || defined svr4
		if (perms.shadow == 1)
			strcpy(password,sp ->sp_pwdp);
#endif
#ifdef DEBUG
	fprintf(stderr,"crypted passw. is <%s>\n",password);
#endif
	sprintf(tmp,"%s%s",ip,password);
        sprintf(key,"%08x",crc32field(tmp));
	calc_string(key,password);
	if (!strcmp(key,pa))	{
#ifdef DEBUG
		fprintf(stderr,"user <%s> verified\n",us);
#endif
		if (perms.log)
			syslog(LOG_NOTICE|LOG_USER,"%s: User logged in",us);
		verified = 1;
		if (setgid(p->pw_gid)) {
			if (perms.log)
				syslog(LOG_NOTICE|LOG_USER,"Can't setgid()");
			printf("999 Cannot setgid()\r\n");
			exit(1);
			}
		if (setuid(p->pw_uid))	{
			if (perms.log)
				syslog(LOG_NOTICE|LOG_USER,"Can't setuid()");
			printf("999 Cannot setuid()\r\n");
			exit(1);
			}
		if (chdir(p->pw_dir))	{
			if (perms.log)
				syslog(LOG_NOTICE|LOG_USER,"Can't chdir to %s",
				p->pw_dir);
			printf("999 Cannot chdir(%s)\r\n",p->pw_dir);
			exit(1);
			}
		return;
		}
#ifdef DEBUG
	fprintf(stderr,"unvalid password for user <%s> <%s>\n",us,pa);
#endif
	if (perms.log)
		syslog(LOG_NOTICE|LOG_USER,"%s: User access denied",us);
	us[0] = pa[0] = 0;
}








get_line(char *s,int la)
{
	char c;
	int lx = 0;
	int a;

	while (1)
	{
		a = read(0,&c,1);
		if (a <= 0)	{
			printf("netfd: Connection closed\n");
			exit(1);
			}
		if (lx >= la)
			continue;
		if (c == 13)
			continue;
		if (c == 10)
			break;
		s[lx++] = c;
		}
	s[lx] = 0; 
#ifdef DEBUG
	fprintf(stderr,"fromnet: <%s>\n",s);
#endif
}
		
brk_args(char *s)
{
	int e,a,b,c,qc,qs;
	int la;
	char ret[MAXLINE];
	char ww[10];
	char *t;
	int quon;
	char tmp[MAXLINE+50];
	char tmpx[MAXLINE+50];
	char iline[MAXLINE+50];
	char loc_arg[20][MAXLINE];
	int loc_cnt = 0;
	int hv_stray = 0;		

	for (a = 0; a < 20; a++)
		loc_arg[a][0] = brk_arg[a][0] = 0;

	if (s[0] == '#' || s[0] == 10)
		return (0);

	strip_this(s);

	brk_cnt = 0;

	quon = la = 0;

	strcpy(iline,s);
	for (a = 0; a <= strlen(s); a++)	{



		if (s[a] == '\\')	{
			hv_stray = 1;
			continue;
			}

		if (s[a] == '\"' && hv_stray == 0)	{
			b = quon;
			if (b)	
				quon = 0;
			else	
				quon = 1;
			}

		hv_stray = 0;

		if (s[a] == '#' && quon == 0 && hv_stray == 0)
			break;

		if (s[a] == 0 || s[a] == ' ' || s[a] == '\t')	{ 
			if (s[a]!= 0 && (quon || hv_stray))	{
				hv_stray = 0;
				continue;
				}

			qc = 0;

			if (s[la] == '\"' && hv_stray == 0)	{
				qc = 1;
				strcpy(tmp,&s[la+1]);
				}
			else
				strcpy(tmp,&s[la]);

			for (b = 0; b < strlen(tmp); b++)	{
				if (qc == 1)	{
					if (tmp[b] == '\\')	{
						qs = 1;
						continue;
						}

					if (tmp[b] == '\"' && qs == 0)	{
						tmp[b] = 0;
						quon = qc = 0;
						break;
						}
					qs = 0;
					}
				if (qc == 0)	{
					if (tmp[b] == ' ' || tmp[b] == '\t')	{
						tmp[b] = 0;
						break;
						}

					}
				}

			if (qc == 1)
				return -1;

			strcpy(brk_arg[brk_cnt++],tmp);

			b = 0;
			while (1)	{
				if (s[a] == ' ' || s[a] == '\t')	{
					a++;
					b = 1;
					continue;
					}
				break;
				}
			la = a;
			a-=b;
			hv_stray = 0;
			}


		}


	if (quon)
		return -1;
	return 0;
}



strip_this(char *s)
{
	if (s[strlen(s)-1] == 10)
		s[strlen(s)-1] = 0;
}


ltrim(char *s)
{
	int a;
	char *tmp;

	tmp = (char *)malloc(strlen(s)+1);

	for (a = 0; a < strlen(s); a++)	{
		if (s[a] !=  ' ' && s[a] != '\t')	{
			strcpy(tmp,&s[a]);
			strcpy(s,tmp);
			break;
			}
		}
	free (tmp);
}

rtrim(char *s)
{
	int a;

	for (a = strlen(s); a > 0; a--)	{
		if (s[a] != 0 && s[a] != ' ' && s[a] != '\t')	{
			s[a+1] = 0;
			return;
			}
		}
}


llink(char *s)
{
	char *t, *dest, *target;
	int a;

	t = (char *)malloc(strlen(s)+1);
	for (a = 0; a < strlen(s); a++)	{
		if (s[a] == ' ')	{
			strcpy(t,&s[a+1]);
			break;
			}
		}
	for (a = 0; a < strlen(t); a++)	{
		if (t[a] == ' ')	{
			dest = &t[a+1];
			t[a] = 0;
			break;
			}
		}
#ifdef DEBUG
	printf("link <%s> <%s>\n",
		t,
		dest);
#endif
	if(test_open(t,"r"))	{
		a = errno;
		free(t);
		return (a);
		}
	
	if(test_open(dest,"w"))	{
		a = errno;
		free(t);
		return (a);
		}

	a = link(t,dest);
	if (a != 0)
		a = errno;
	free(t);
	return (a);
}


rrename(char *s)
{
	char *t, *dest, *target;
	int a;

	t = (char *)malloc(strlen(s)+1);
	for (a = 0; a < strlen(s); a++)	{
		if (s[a] == ' ')	{
			strcpy(t,&s[a+1]);
			break;
			}
		}
	for (a = 0; a < strlen(t); a++)	{
		if (t[a] == ' ')	{
			dest = &t[a+1];
			t[a] = 0;
			break;
			}
		}
#ifdef DEBUG
	printf("rename <%s> <%s>\n",
		t,
		dest);
#endif
	if(test_open(t,"r"))	{
		a = errno;
		free(t);
		return (a);
		}
	
	if(test_open(dest,"w"))	{
		a = errno;
		free(t);
		return (a);
		}

	a = rename(t,dest);
	if (a != 0)
		a = errno;
	free(t);
	return (a);
}


net_removetree(char *s,char *ans,int mode)
{
	DIR *dir;
	struct dirent *entry;
	char tmp[5000];
	int ok = -1;
	struct stat stb;


	if (stat(s,&stb))	{
		strcpy(ans,s);
		return (-1);
		}

	dir_size += stb.st_size;

	if (lstat(s,&stb))	{
		strcpy(ans,s);
		return (-1);
		}


	if ((stb.st_mode & S_IFMT) != S_IFDIR ||
		(stb.st_mode & S_IFMT) == S_IFLNK)	{
		if (mode == 1) 	{
			if (munlink(s))	{
				strcpy(ans,s);
				return (-1);
				}
			}
		return (0);
		}


	dir = opendir(s);

	if (dir == (DIR *)NULL)	{
		strcpy(ans,s);
		return (-1);
		}

	while (1)	{
		entry = readdir(dir);
		if (entry == (struct dirent *)NULL)	{
			ok = 0;
			break;
			}
		if(entry->d_ino == 0)
			continue;
		if (entry->d_name[0] == '.' && entry->d_name[1] == 0)
			continue;
		
		if (entry->d_name[0] == '.' && entry->d_name[1] == '.' 
			&& entry->d_name[2] == 0)
			continue;
		sprintf(tmp,"%s/%s",s,entry->d_name);
	
		if (stat(tmp,&stb))	{
			strcpy(ans,tmp);	
			break;
			}

		dir_size += stb.st_size;

		if (lstat(tmp,&stb))	{
			strcpy(ans,tmp);	
			break;
			}

		if ((stb.st_mode & S_IFMT) == S_IFDIR)	{
			if (net_removetree(tmp,ans,mode))
				break;
			continue;
			}

		if (mode == 1)	{
			if (unlink(tmp))	{
				strcpy(ans,tmp);
				break;  
				}
			}
		}
	closedir(dir);
	if (ok == 0 && mode == 1)	{
		if (rmdir(s))
			ok = -1;
		} 	
	return (ok);
}


net_expand(char *s)
{
	struct dirent *entry;
	DIR *dir;
	char fina[2048];
	char cdir[2048];
	int a;
	char tmp[2048];


	get_sdir(s,cdir,fina);

	dir = opendir(cdir);
	if (dir == (DIR *)NULL)
		return (errno);

	if (fina[0] == 0)	{
		sprintf(tmp,"127 099 %s\n",cdir);
		net_write(tmp);
		closedir(dir);
		return (0);
		}

	while (1)	{
		entry = readdir(dir);
		if (entry == (struct dirent *)NULL)
			break;
		if(entry->d_ino == 0)
			continue;
		if (entry->d_name[0] == '.' && entry->d_name[1] == 0)
			continue;
		if (entry->d_name[0] == '.' && entry->d_name[1] == '.' 
			&& entry->d_name[2] == 0)
			continue;
		if(!stest(entry->d_name,fina))
			continue;
		if (!strcmp(cdir,"."))
			sprintf(tmp,"127 099 %s\n",entry->d_name);
		else
			sprintf(tmp,"127 099 %s/%s\n",cdir,entry->d_name);
		net_write(tmp);
		}
	closedir(dir);
	return (0);
}
		
			
stest(char *s1, char *s2)
{
	char *tst;
	int ok = 0;
	char *kk;
	char txt[2048]; 
	char txp[2048];
	int a;


	if (!strcmp(s2,"*"))
		return (1);

	if (s2[0] == '*' && s2[strlen(s2)-1] == '*')	{
		strcpy(txt,&s2[1]);
		txt[strlen(txt)-1] = 0;
		if (strlen(txt) > strlen(s1))
			return (0);
		for (a = 0; a <= strlen(s1) - strlen(txt); a++)	{
			if (!strncmp(&s1[a],txt,strlen(txt)))	{
				ok = 1;
				break;
				}
			}
		return (ok);
		}


	if (s2[strlen(s2)-1] == '*')	{
		strcpy(txt,s2);
		txt[strlen(txt)-1] = 0;
		if (strlen(txt) > strlen(s1))
			return (0); 
		if (!strncmp(s1,txt,strlen(txt)))
			return (1);
		return (0);
		}


	if (s2[0] == '*')	{        /* i.e. "*.c" */
		tst = (char *)&s2[1];
		fflush(stdout);
		if (strlen(tst) > strlen(s1))
			return (0);
		kk = &s1[strlen(s1)-strlen(tst)];
		if (!strcmp(kk,tst))
			ok = 1;
		return (ok);
		}

	if (!strcmp(s1,s2))
		return (1);

	return (0);
}


get_sdir(char *s, char *dir, char *file)
{
	char vorsl[2048];
	char nachsl[2048];
	char tmp[2048];
	char work[2048];
	int a;
	char *t;

#ifndef GREAT_SERVER
	char *uhome = (char *)getenv("HOME");
#endif
	strcpy(vorsl,s);

	if (vorsl[0] == '.' && vorsl[1] != '.')	{
		sprintf(tmp,"%s%s",getcwd(NULL,2000),&vorsl[1]);
		strcpy(vorsl,tmp);
		}

	if (vorsl[0] == '~')	{
		sprintf(tmp,"%s%s",uhome,&vorsl[1]);
		strcpy(vorsl,tmp);
		}
	
	if (vorsl[0] != '/')	{
		sprintf(tmp,"%s/%s",getcwd(NULL,2000),vorsl);
		strcpy(vorsl,tmp);
		}

	strcpy(tmp,vorsl);
	a = 0;
	work[0] = 0;
	while (1)	{
		if (a == 0)
			t = (char *)strtok(tmp,"/");
		else
			t = (char *)strtok(NULL,"/");
		a = 1;
		if (t == NULL)
			break;
		if (!strcmp(t,"."))
			continue;
		if (!strcmp(t,".."))	{
			for (a = strlen	(work); a >= 0; a--)	{
				if (work[a] == '/')	{
					if (a == 0)
						work[1] = 0;
					else
						work[a] = 0;
					break;
					}
				}
			a = 1;
			continue;
			}
		strcat(work,"/");
		strcat(work,t);
		}

	if (work[0] == 0)	
		strcpy(work,vorsl);

	for (a = strlen(work); a >= 0; a--)	{
		if (work[a] == '/')	{
			strcpy(nachsl,&work[a+1]);
			strcpy(vorsl,work);
			if (a == 0)
				vorsl[1] = 0;
			else
				vorsl[a] = 0;
			break;
			}
		}
	strcpy(dir,vorsl);
	strcpy(file,nachsl);
	return (0);
}

read_conf()
{
	FILE *fp;
	char tmp[2048];

	perms.no_root = 1;
	perms.shadow = 0;
#ifdef svr4
	perms.shadow = 1;
#endif
	perms.no_special = 1;
	perms.no_root_files = 1;
	perms.read_only = 0;
	perms.log = 0;
	perms.stream = 0;
	perms.logall = 0;
	perms.guest = (char *)NULL;
	perms.chroot = (char *)NULL;
	perms.guest_uid = 999;

	fp = fopen("/etc/netfd.conf","r");
	if (fp == NULL)	{
		printf("Can't read /etc/netfd.conf\n");
		return;
		}
	while (fgets(tmp,2047,fp) != NULL)	{
		if (tmp[0] == '#' || tmp[0] == 0)
			continue;
		brk_args(tmp);
		if (!strcmp("guest*login", brk_arg[0]))	{
			perms.guest = (char *)malloc(strlen(brk_arg[1])+1);
			strcpy(perms.guest,brk_arg[1]);
			continue;
			}
		if (!strcmp("guest*chroot",brk_arg[0]))	{
			perms.chroot = (char *)malloc(strlen(brk_arg[1])+1);
			strcpy(perms.chroot,brk_arg[1]);
			continue;
			}
		if (!strcmp("guest*uid",brk_arg[0]))	{
			perms.guest_uid = atoi(brk_arg[1]);
			continue;
			}
		if (tmp[strlen(tmp)-1] == 10)
			tmp[strlen(tmp)-1] = 0;

		if (!strcmp(tmp,"set*shadow*true"))	{
			perms.shadow = 1;
			continue;
			}

		if (!strcmp(tmp,"set*log*true"))	{
			perms.log = 1;
			continue;
			}
		if (!strcmp(tmp,"set*log*all*true"))	{
			perms.logall = 1;
			continue;
			}
		if (!strcmp(tmp,"set*special*false"))	{
			perms.no_special = 0;
			continue;
			}
		if (!strcmp(tmp,"use*stream*ok"))	{
			perms.stream = 1;
			continue;
			}
		if (!strcmp(tmp,"set*read_only*true"))	{
			perms.read_only = 1;
			continue;
			}
		if (!strcmp(tmp,"set*root_file_access*false"))	{
			perms.no_root_files = 1;
			continue;
			}
		if (!strcmp(tmp,"set*root_file_access*true"))	{
			perms.no_root_files = 0;
			continue;
			}
		if (!strcmp(tmp,"set*root_login*true"))	{
			perms.no_root = 0;
			continue;
			}
		if (!strcmp(tmp,"set*root_login*false"))	{
			perms.no_root = 1;
			continue;
			}

		}
	fclose(fp);

	if (perms.log)
		openlog("netfd",LOG_CONS,LOG_USER);

	if (VERBOSE)	{
		printf("Configuration data\n\n");
		if (perms.guest != NULL)
			printf("anonymous access with login: %s (UID=%d)\n"
				,perms.guest
				,perms.guest_uid);
		if (perms.chroot != NULL)
			printf("will chroot to: %s\n",perms.chroot);
#ifdef linux 
		printf("Using shadow passwords: ");
		if (perms.shadow)
			printf("yes\n");
		else
			printf("no\n");
#endif 
		printf("StreamCopy: ");
		if (perms.stream)
			printf("ok\n");
		else
			printf("denied\n");
		printf("log to syslog: ");
		if (perms.log)
			printf("yes\n");
		else
			printf("no\n");
		printf("log all command input to syslog: ");
		if (perms.logall)
			printf("yes\n");
		else
			printf("no\n");
		printf("files read only: ");
		if (perms.read_only)
			printf("yes\n");
		else
			printf("no\n");
		printf("root may login: ");
		if (perms.no_root)
			printf("no\n");
		else
			printf("yes\n");
		printf("file access to root owned files: ");
		if (perms.no_root_files)
			printf("no\n");
		else
			printf("yes\n");
		}
	return(0);
}





send_info(char *s)
{
	FILE *fp;
	char tmp[2048];
	char tmpx[2048];
	int a,ok;


	if (!strcmp(&s[4],"@perms"))	{
		sprintf(tmp,"135 001 File Read-Only: ");
		if (perms.read_only)
			strcat(tmp,"yes\n");
		else
			strcat(tmp,"no\n");
		net_write(tmp);
		sprintf(tmp,"135 001 Root Login: ");
		if (perms.no_root)
			strcat(tmp,"denied\n");
		else
			strcat(tmp,"ok\n");
		net_write(tmp);
		sprintf(tmp,"135 001 Access to root owned files: ");
		if (perms.no_root_files)
			strcat(tmp,"denied\n");
		else
			strcat(tmp,"ok\n");
		net_write(tmp);
		sprintf(tmp,"135 000\n"); 
		net_write(tmp);
		return (0);
		}

	fp = fopen("/etc/netfd.conf","r");

	if (fp == NULL)	{
		sprintf(tmp,"135 000\n");
		net_write(tmp);
		return (0);
		}
	for (a = strlen(s); a > 0; a--)	{
		if (s[a] == '@')	{
			strcpy(tmp,&s[a]);
			break;
			}
		}
	ok = 0;
	while(fgets(tmpx,2047,fp) != NULL)	{
		tmpx[strlen(tmpx)-1] = 0;
		if (ok == 1)	{
			if (tmpx[0] == '@')
				break;
			} 
		if (ok == 0 && !strcmp(tmpx,tmp))	{
			ok = 1;
			continue;
			}
 		if (ok == 0)
			continue;
		sprintf(tmp,"135 001 %s\n",tmpx);
		net_write(tmp);
		}
	fclose(fp);
	sprintf(tmp,"135 000\n"); 
	net_write(tmp);
	return (0);
}


copy (char *s1, char *s2)
{
	struct stat sts,std;
	char target[2048];
	char source[2048];
	char sfile[1024];
	int a; 
	char tmp[2048];


	strcpy(sfile,s1); 
	strcpy(target,s2);
	
	for (a = strlen(s1); a >= 0; a--)	{
		if (s1[a] == '/')	{
			strcpy(sfile,&s1[a+1]);
			break;
			}
		}

	if (lstat(s1,&sts))	{
		sprintf(tmp,"136 002 Can't stat %s\n",s1);
		net_write(tmp);
		return (-1);
		}

 	if (!lstat(s2,&std))	{
		if ((sts.st_mode & S_IFMT) == S_IFDIR && 
			(std.st_mode & S_IFMT) != S_IFDIR)	{
				errno = ENOTDIR;
			sprintf(tmp,"136 002 Target must be a directory\n");
			net_write(tmp);
			return (-1);
			}

		if ((std.st_mode & S_IFMT) == S_IFDIR)	
			sprintf(target,"%s/%s",s2,sfile);

		if (!lstat(target,&std))	{
			if ((sts.st_mode & S_IFMT) == S_IFDIR && 
				(std.st_mode & S_IFMT) != S_IFDIR)	{
					errno = ENOTDIR;
				sprintf(tmp,"136 002 Target mus be a directory\n",s1);
				net_write(tmp);
				return (-1);
				}
			}
		}

 	if ((sts.st_mode & S_IFMT) == S_IFDIR)	
		return(copydir(s1,target));

	return(copyfile(s1,target));
}


copydir(char *s1, char *s2)
{
	struct stat stb;
	struct dirent *entry;
	DIR *dir;
	char target[2048];
	char source[2048];
	char tmp[2048];
 	int ok;
	int a;

 	if (lstat(s1,&stb))	{
		sprintf(tmp,"136 002 Can't stat %s\n",s1);
		net_write(tmp);
		return (-1);
		} 

	dir = opendir(s1);
	if (dir == (DIR *)NULL)	{
		sprintf(tmp,"136 002 Can't opendir %s\n",s1);
		net_write(tmp);
		return (-1);
		}

	ok = -1;

#ifdef COPYDEBUG
	printf("copydebug: Creating DIR <%s>\n",s2);
	fflush(stdout);
#else
	if (mkdir(s2,stb.st_mode))	{
		a = errno;
		closedir(dir);
		sprintf(tmp,"136 002 Can't createdir %s\n",s2);
		net_write(tmp);
		errno = a;
		return(-1);
		}
#endif
	strcpy(target,s2);
	while (1)	{
		entry = readdir(dir);
		if (entry == (struct dirent *)NULL)	{
			ok = 0;
			break;
			} 
		if (entry->d_name[0] == '.' &&
			(entry->d_name[1] == '.' && entry->d_name[2] == 0))
			continue;

		if (entry->d_name[0] == '.' &&
			entry->d_name[1] == 0)
			continue;
		sprintf(target,"%s/%s",s2,entry->d_name);
		sprintf(source,"%s/%s",s1,entry->d_name);
		if (lstat(source,&stb))	{
			sprintf(tmp,"136 002 Can't stat %s\n",source);
			net_write(tmp);
			continue;
			}
		if ((stb.st_mode & S_IFMT) == S_IFDIR)	{
			copydir(source,target);
			continue;
			}
 		copyfile(source,target);
		}
	closedir(dir);
	return (ok);
}		
			

copyfile (char *s1, char *s2)
{
	struct stat sts;
	int hdi,hdo;
	int a,ok; 
	char tbuff[2047];
	char tmp[2048];


	if (lstat(s1,&sts))	{
		sprintf(tmp,"136 002 Can't stat %s\n",s1);
		net_write(tmp);
		return (-1);
		}

#ifdef COPYDEBUG
	printf("copydebug: <%s> -> <%s>\n",s1,s2);
	fflush(stdout);
	return (0);
#endif
	if(test_open(s1,"r"))	{
		sprintf(tmp,"136 002 File access denied\n");
                net_write(tmp);
                return (-1);
		}

	hdi = open(s1,O_RDONLY);
	if (hdi <= 0)	{
		sprintf(tmp,"136 002 Can't read-open %s\n",s1);
		net_write(tmp);
		return (-1); 
		}

	if(test_open(s2,"w"))	{
		sprintf(tmp,"136 002 File access denied\n");
                net_write(tmp);
                return (-1);
		}

	hdo = open(s2,O_WRONLY|O_CREAT|O_TRUNC,0600);
	if (hdo <= 0)	{
		sprintf(tmp,"136 002 Can't write-open %s\n",s2);
		net_write(tmp);
		close(hdi);
		return (-1);
		}

	ok = 0;

	while (1)	{
		a = slow_read(hdi,tbuff,2048);
		if (a < 0)	{
			sprintf(tmp,"136 002 Readerror file: %s\n",s1);
			net_write(tmp);
			break;
			}
		if (a == 0)	{
			ok = 1;
			break;
			}
		if (slow_write(hdo,tbuff,a) != a)	{
			sprintf(tmp,"136 002 Writeerror file %s\n",s2);
			net_write(tmp);
			break;
			}
		}
	close(hdi);
	close(hdo); 
	if (!ok)	{
		a = errno; 
		unlink(s2); 
		errno = a;
		return (-1);
		}

	if (chmod(s2,sts.st_mode)) 	{
		sprintf(tmp,"136 002 Can't chmod %s\n",s2);
		net_write(tmp);
		return (-1);
		}

	return (0);
}


net_copy(char *s1)
{
	int a;

	for (a = 0; a < strlen(s1); a++)	{
		if (s1[a] == ' ')	{
			s1[a] = 0;
			return (copy(s1,&s1[a+1]));
			}
		}
	return (-1);
}

slow_write(int hd,char *s,int sz)
{
	int pos;
 	int a;
	int written = 0;
	int tz;
	
	pos = 0;
	tz = sz;  


	while (1)	{
		a = write(hd,&s[pos],tz);
		if (a < 0)
			return (-1);
		pos +=a;
		tz -= a;
#ifdef DEBUG
		printf("slow_write: written <%d> towrite <%d>\n",pos,tz);
#endif
		if (pos >= sz)
			return (pos);
		}
}
		

slow_read(int hd, char *s, int sz)
{
	int pos;
 	int a;
	int written = 0;
	int tz;
	
	pos = 0;
	tz = sz;  


	while (1)	{
		a = read(hd,&s[pos],tz);
		if (a < 0)
			return (-1);
		pos +=a;
		tz -= a;
#ifdef DEBUG
		printf("slow_read: have <%d> still want <%d>\n",pos,tz);
#endif
		if (pos >= sz)
			return (pos);
		}
}

open_resource(char *s,char *mo)
{
	char tmpx[2048];
	FILE *fp;
	char what[2048];
	char xmo[100];
	char mod[100];



	fp = fopen("/etc/netfd.conf","r");
	if (fp == NULL)
		return (-2);
	while (fgets(tmpx,2047,fp) != NULL)	{
		if (tmpx[0] != '$')
			continue;
		brk_args(&tmpx[1]);
		if(!strcmp(s,brk_arg[0]))	{
			strcpy(what,brk_arg[4]);
			strcpy(xmo,brk_arg[3]);
			strcpy(mod,brk_arg[2]);
			fclose(fp);
			if (!strcmp(mo,"r"))	{
				if (!strcmp(mod,"rw") 
				|| !strcmp(mod,"wr")
				|| !strcmp(mod,"r"))	{
					if (!strcmp(xmo,"file"))	{
						fp = fopen(what,"r");
						if (fp != NULL)
							return (fileno(fp));
						return (0);
						}
					if (!strcmp(xmo,"exec"))	{
						fp = popen(what,"r");
                	          		if (fp != NULL)
                        	                	return (fileno(fp)); 
                                		return (0);      
                        	        	}
					return (-7);
					}
				return (-3);
				}

			if (!strcmp(mo,"w"))	{
				if (!strcmp(mod,"rw") 
				|| !strcmp(mod,"wr")
				|| !strcmp(mod,"w"))	{
					if (!strcmp(xmo,"file"))	{
						fp = fopen(what,"w");
						if (fp != NULL)
							return (fileno(fp));
						return (0);
						}
					if (!strcmp(xmo,"exec"))	{
						fp = popen(what,"w");
                	          		if (fp != NULL)
                        	                	return (fileno(fp)); 
                                		return (0);      
                        	        	}
					return (-7);
					}
				return (-4);
				}
			fclose(fp);
			return (-5);
			}
		}
	fclose(fp);
	return (-6);
}
			
				
			



display_resources (char *s)
{
	FILE *fp;
	char tmp[2048];
	char tmpx[2048];
	int a,ok;


	fp = fopen("/etc/netfd.conf","r");
	if (fp == NULL)	{
		sprintf(tmp,"136 000\n");
		net_write(tmp);
		return (0);
		}
	ok = 0;
	while(fgets(tmpx,2047,fp) != NULL)	{
		if (tmpx[0] != '$')
			continue;
		brk_args(&tmpx[1]);
		if (s[0] == '*' || !strcmp(s,brk_arg[0]))	{
			sprintf(tmp,"136 001 %s %s %s\n",
				brk_arg[0],
				brk_arg[1],
				brk_arg[2]);
			net_write(tmp);
			}       
		}
	fclose(fp);
	net_write("136 000\n");
	return(0);
}

help_info()
{
	char tmp[1024];

	sprintf(tmp,"GREATCOMM Server on (%s/%s) Version %d.%d ready\n", 
		SERVER_SYSTEM,
		SERVER_OS, 
		VERSION_MAJOR,
		VERSION_MINOR);

	net_write(tmp);
	net_write("GREATCOMM (c) 1993 Free Software Association of Germany\n\n");
	net_write("The following commands are available:\n\n");
	net_write("001 loginname     002 password      003 getcwd\n");
	net_write("004 open read     005 close         006 read\n");
	net_write("007 open write    008 write         009 chdir\n");
	net_write("010 unlink        011 lstat         012 opendir\n");
	net_write("013 chmod         014 mkdir         015 version\n");
	net_write("016 errname       017 access        018 readlink\n");
	net_write("019 link          020 cryptkey      021 lock\n");
	net_write("022 gethome       023 rename        024 open test\n");
	net_write("026 removetree    027 expand        028 stat\n");
	net_write("029 fstat         030 getuid        031 getgid\n");
	net_write("032 getname       033 getgroup      034 treesize\n");
	net_write("035 info          036 resources     037 Internal\n");
	net_write("038 TestDir       039 StreamRead    040 Datastream Req\n");
	net_write("041 StreamWrite   042 StreamPerms   043 Resourcehandling\n");
	net_write("044 Message       045 LocalTime\n");

}
        
get_peerip(char *s)
{
	FILE *fp;
	struct in_addr adress;
	struct sockaddr_in      cli_addr;
        struct hostent  *hp;
        unsigned long ip_addr;
        int     hd,ch, addrlen;

	addrlen = sizeof(cli_addr);
	if (getpeername(0, &cli_addr, &addrlen) < 0)    {
		if (perms.log)
			syslog(LOG_NOTICE|LOG_USER,"Can't get peername");
		printf("999 Can't get peername\n");
                exit(3);
                }
        adress.s_addr = cli_addr.sin_addr.s_addr;
        strcpy(s,inet_ntoa(adress));
	if (perms.log)
		syslog(LOG_NOTICE|LOG_USER,"PeerIP = %s",s);
}

	
Xrand(int s)
{

        next = next * 1103515245 + 12345;
        return ((unsigned int) (next/65536) % s);
}

Xsrand(unsigned int i)
{
        next = i;
}

get_cryptkey(char *us, char *pa,char *ip,char *key)
{
	char *kl = "abcde1234567890fghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!%&/()=?-_:.,;\0";
	struct passwd *p;
#ifndef aix
	struct spwd *sp;
#else
	struct userpw *sp;
#endif
	char salt[3];
	char tp;
	char tmp[20];
	char tst[1024];
	char tsx[500];
	int v,a,b;
	int vv;
	char password[100];

	strcpy(key,"0");
	p = getpwnam(us);
	if (p == (struct passwd *)NULL)
		return (1);
	endpwent();
#ifdef sun
	strcpy(password,p->pw_passwd);
#endif
#if defined linux || defined svr4
	if (perms.shadow == 1)	{
		sp = getspnam(us);
		if (sp == (struct spwd *)NULL)	{
			endspent();
			return(1);
			}
		strcpy(password,sp->sp_pwdp);
		}
	if (perms.shadow == 0)	
		strcpy(password,p->pw_passwd);
#endif
#ifdef aix
	sp = getuserpw(us);
	if (sp == (struct userpw *)NULL)
		return (1);
	strcpy(password,sp->upw_passwd);
#endif
	
#ifdef DEBUG
	fprintf(stderr,"crypted passw. is <%s>\n",password);
#endif	
	salt[0] = password[0];
	salt[1] = password[1];
	salt[2] = 0;

	if (strlen(password) > 13)
		password[13] = 0;	
	
	if (!strcmp(password,(char *)crypt(pa,salt)))	{
#ifdef DEBUG
		fprintf(stderr,"user <%s> verified\n",us);
#endif
		sprintf(tst,"%s%s",ip,password);
		sprintf(key,"%08x",crc32field(tst));
		calc_string(key,password);
		return (0);
		}
#ifdef DEBUG
	fprintf(stderr,"unvalid password for user <%s> <%s>\n",us,(char *)crypt(pa,salt));
#endif
	return (1);
}


calc_string(char *s,char *p)
{
	char *kl = "abcde1234567890fghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!%&/()=?-_:.,;\0";
	int a,b,v,vv;

	b = strlen(kl);
	for (a = 0; a < 8; a++)	{
		v = s[a] + p[a];
		vv = v % b;
		s[a] = kl[vv];
		}
}

int
local_testdir()
{
        struct stat stb;
        int ok;

        if (lstat(g_testdir,&stb))
                return (-1);

        ok = 0;

        if(stb.st_atime != g_testdirstb.st_atime)
                ok = 1;
        if (stb.st_mtime != g_testdirstb.st_mtime)
                ok = 2;
        if (stb.st_ctime != g_testdirstb.st_ctime)
                ok = 3;
       if (ok) {
                g_testdirstb.st_atime = stb.st_atime;
                g_testdirstb.st_mtime = stb.st_mtime;
                g_testdirstb.st_ctime = stb.st_ctime;
                }

        return(ok);
}


test_open(char *s, char *mode)
{
	struct stat stb;
	int serr = 0;
	int ok = 1;

	serr = lstat (s,&stb);
	if (perms.no_special && !serr)	{
		if ((stb.st_mode & S_IFMT) == S_IFSOCK)
			ok = 0;
		if ((stb.st_mode & S_IFMT) == S_IFBLK)
			ok = 0;
                if ((stb.st_mode & S_IFMT) == S_IFCHR) 
			ok = 0;
                if ((stb.st_mode & S_IFMT) == S_IFIFO) 
			ok = 0;
		if (!ok)	{
			errno = EPERM;
			if (perms.log)
				syslog(LOG_NOTICE|LOG_USER,"open <%s,%s> i(special) denied",s,mode);
			return(-1);
			}
		}
	if (!strcmp(mode,"w") && perms.read_only)	{
		errno = EROFS; 
		return (-1);
		if (perms.log)
			syslog(LOG_NOTICE|LOG_USER,"open <%s,%s> denied",s,mode);
		}

	if (!strcmp(mode,"a") && perms.read_only)	{
		errno = EROFS; 
		if (perms.log)
			syslog(LOG_NOTICE|LOG_USER,"open <%s,%s> denied",s,mode);
		return (-1);
		}

	if (serr)	{
		if (perms.log)
			syslog(LOG_NOTICE|LOG_USER,"open <%s,%s> ok ",s,mode);
		return (0);
		}

	if (stb.st_uid == 0 && perms.no_root_files)	{
		if (perms.log)
			syslog(LOG_NOTICE|LOG_USER,"open <%s,%s> denied",s,mode);
		errno = EACCES; 
		return (-1);
		}

	if (perms.log)
		syslog(LOG_NOTICE|LOG_USER,"open <%s,%s> ok",s,mode);
	return (0);
}


munlink(char *s)
{
	if (!test_open(s,"r") && !test_open (s,"w"))
		return (unlink(s));
	return (-1);
}


change_root()
{
	if (chroot(perms.chroot))	{
		printf("999 Cannot change root\n");
		if (perms.log)
			syslog(LOG_NOTICE|LOG_USER,"Can't chroot(%s),%s",perms.chroot,sys_errlist[errno]);
		exit(1);
		}
	if (perms.log)
		syslog(LOG_NOTICE|LOG_USER,"chroot(%s) ok",perms.chroot);
	return (0);
}


datastream(char *tmp)
{
	char host[100];
	char port[100];

	if (data_handle != -1)
		close(data_handle);

	data_handle = -1;


	brk_args(tmp);
	
	
#ifdef DEBUG
	printf("DATACONNECTION to <%s>\n",brk_arg[1]);
#endif
	if (perms.log)
		syslog(LOG_NOTICE|LOG_USER,"Dataconnection to %s",brk_arg[1]);
	return(tcp_open(brk_arg[1],NULL,atoi(brk_arg[2])));
}
	

tcp_open(host, service,port)
char *host;
char *service;
int port;
{
	struct in_addr adress;
	unsigned long ip_addr;
	int len;
	int fd, resvport;
	unsigned long inaddr;
	struct servent *sp;
	struct hostent *hp;

	bzero(( char *) &tcp_srv_addr, sizeof(tcp_srv_addr));
	tcp_srv_addr.sin_family = AF_INET;

	tcp_srv_addr.sin_port = htons(port);

	if ((inaddr = inet_addr(host)) != INADDR_NONE)	{
		bcopy((char *) &inaddr, (char *) &tcp_srv_addr.sin_addr,
			sizeof(inaddr));
		bcopy((char *) &inaddr, (char *) &adress.s_addr,
			sizeof(inaddr));
		tcp_host_info.h_name = NULL;
		}
	else	{
		if (( hp = gethostbyname(host)) == NULL)
			return (-3);	
		tcp_host_info = *hp;
		bcopy(hp->h_addr, (char *) &tcp_srv_addr.sin_addr,
			hp->h_length);
		bcopy(hp->h_addr, (char *) &adress.s_addr,
			hp->h_length);
		}


	if (port >= 0)	{
		if ((fd = socket(AF_INET, SOCK_STREAM,0)) < 0)	
			return (-4);
		}
	else if (port < 0)	{
		resvport = IPPORT_RESERVED -1;
		if (( fd = rresvport(&resvport) < 0))	
			return (-5);
		}
	if (connect(fd, (struct sockaddr *) &tcp_srv_addr,
		sizeof(tcp_srv_addr)) < 0)	{
		close(fd);
		return (-6);
		}

	len = sizeof (myctladdr);
	if (getsockname(fd, (struct sockaddr *)&myctladdr, &len) < 0) {
		perror("ftp: getsockname");
		close(fd);
		return(-7);
		}
	return (fd);
}

data2user(char *s)
{
	char tmp[1024];
	char *ty[4];
	struct sockaddr_un msock,isock;
        int domain, nfds, rhd,flen;
        int shd,a;
        int lhd;
        unsigned char c;

	a = 0;
	while (1)	{
		if (a == 0)
			ty[a] = (char *)strtok(s," ");
		else
			ty[a] = (char *)strtok(NULL," ");
		if (a >= 4 || ty[a] == NULL)
			break;
		a++;
		}

	sprintf(tmp,"/tmp/dce_%s",ty[0]);
        strcpy(msock.sun_path,tmp);
        msock.sun_family = AF_UNIX;
        shd = socket(AF_UNIX, SOCK_STREAM, 0);
        if (shd < 0) 
                return (-1);
        if (connect(shd, (struct sockaddr *)&msock, strlen(msock.sun_path) + 2) < 0)
                return (-1);
	sprintf(tmp,"%s*%s\n",ty[1],ty[2]);
	if (write(shd,tmp,strlen(tmp)) != strlen(tmp))
		return (-1);
	if (read(shd,tmp,5) <= 0)
		return (-1);
	if (tmp[0] == '0')
		return -2;
	if (tmp[0] == '2')
		return -3;
	sprintf(tmp,"144 000\n");
	net_write(tmp);
	while (1)	{
		a = read(0,tmp,512);
		if (a <= 0)
			break;
		if (write(shd,tmp,a) != a)
			break;
		}
	close(shd);
	exit(0);
}
